var useragent = require('useragent'),
    ejs = require('ejs'),
    fs = require('fs');
var viewpath = process.cwd() + '/views';
var brr_inner = function (name, json) {
    var that = arguments.callee;
    var str = fs.readFileSync(viewpath + '/brr/' + name + '.ejs', 'utf8');
    return ejs.render(str, {
        locals: {
            arg : json,
            brr : that
        }
    });
}
var brr_depend = 
function (brr) {
return function () {
    var that = brr;
    var str = fs.readFileSync(viewpath + '/brr/depend.ejs', 'utf8');
    return ejs.render(str, {
        locals: {
            arg : that.required,
            brr : that
        }
    });
};
};
var brr_require = 
function (arr) {
return function (name) {
    if (arr.indexOf(name) === -1) {
        arr.push(name);
    }
};
};
var brr_argc = function (arg) {
    var ret = '';
    for (var str in arg) {
        if (str.match(/^[a-zA-Z_:][\-a-zA-Z0-9_:\.]+$/))
        ret += ' ' + str + '="'+arg[str].toString()
            .replace(/</g,'&lt')
            .replace(/>/h,'&gt;')
            .replace(/"/g,'&quot;') + '"';
    }
    return ret;
};
var burari = function (req, json) {
    json.brr = brr_inner;
    json.brr.required = [];
    json.brr.depend = brr_depend(json.brr);
    json.brr.require = brr_require(json.brr.required);
    json.brr.argc = brr_argc;
    json.brr.oldie = true;
    var ua = useragent.browser(req.headers['user-agent'] || '');
    if (parseInt(ua.version, 10) < 9 && ua.ie) {
        json.brr.oldie = true;
    }
    return json;
};
burari.set = function (json) {
    if (json.views) {
        viewpath = json.views;
    }
    return burari;
};
module.exports = burari;